package bresenham;

import java.awt.Color;
import java.awt.Graphics;

public class Diagram  
{
    static final int ZOOM = 2;
    static final int SIZE = 1000;

    boolean[][] pixels; // the pixels we've filled in -- used for redrawing
    int points;

    Diagram(){
        super();
        pixels = new boolean[SIZE][SIZE];
    }

    public void clear(){
        points = 0;
        for(int i = 0; i < SIZE; i++) 
            for(int j = 0; j < SIZE; j++)
                pixels[i][j] = false;

        repaint();
    }

    public void setPixel(int x, int y){
        pixels[x][y] = true;
        
        repaint(/*int x,
                  int y,
                  int width,
                  int height*/);
        // make this just do the pixel we've changed
    }
    
    public void repaint()
    {
    	
    }
    
    // Draw the points that we've saved in the array.
    public void paint(Graphics g) {
        
        g.setColor(Color.black);
        for(int i = 0; i < SIZE; i++)
            for(int j = 0; j < SIZE; j++)
                if(pixels[i][j]){
                    g.fillRect(ZOOM*i, ZOOM*j, ZOOM, ZOOM );
                }
    }
}
