package coinchanging;

/**
 * 
 * Changes:
 * 
 * Added test method.
 * Added assertion in change
 * 
 *
 */
class Greedy {
        
	public static void test(int amount)
	{
		int change = change(amount, new int[] {10,5,2});
		if (amount > 0) {
			assert(change > 0 && change <= amount);
		}
		else {
			assert(change == 0);
		}
	}
	
  public static int change(int amount, int[] coins){
    int noCoins = 0; 

    for (int i=0; i<coins.length; i++) {
      if (amount >= coins[i]) {
        noCoins += amount / coins[i];
        amount  %= coins[i];
      }
    }
    assert amount == 0 : "We should always be able to return coins";
    return(noCoins);
  }
}
