package dynamic;

/**
 * 
 * Default parameters, of course has an heapoverflow for large values of n.
 *
 */
class ArrayFib{
	
	public void test(int n)
	{
		assert(fib(0) == 0);
		assert(fib(1) == 1);
		assert(fib(2) == 1);
		assert(fib(3) == 2);
		assert(fib(4) == 3);
		assert(fib(5) == 5);
		if (n > 5) {
			assert(fib(n) > n);
		}
	}
	
    public static int fib(int n){
        int [] F = new int[n]; 

        switch(n){
        case 0:  return 0;
        case 1:  return 1;
        default: 
            F[0] = 0;
            F[1] = 1;
            for (int i = 2; i < n; i++){
                F[i] = F[i - 1] + F[i - 2];
            }
            return F[n - 1] + F[n - 2];
        } 
    }
}
