package dynamic;

/**
 * 
 * No changes, full coverage with default parameters.
 *
 */
class Fibonacci{
	
	public void test(int n)
	{
		assert(fib(0) == 0);
		assert(fib(1) == 1);
		assert(fib(2) == 1);
		assert(fib(3) == 2);
		assert(fib(4) == 3);
		assert(fib(5) == 5);
		if (n > 5) {
			assert(fib(n) > n);
		}
	}
	
    public static int fib(int n){
        int prev = 0 ; 
        int fib  = 1 ;
        for(int i = 1 ; i < n; i++) {
            int next = prev + fib ;
            prev     = fib  ;
            fib      = next ;
        }
        return fib; // fib = fib(n)
    }
}
