package greedy;

import java.util.*;

class TestHuffman {
  private static String codeWord(Node n) {
    if (n.parent == null) return "";
      else return (codeWord(n.parent) + n.bit);
  }
 
  public static void printCodes(LinkedList l) {
      Iterator i = l.iterator();
      while (i.hasNext()) {
        Node n = (Node) i.next();       
        System.out.println(n.character + "=" + codeWord(n));
      }  
  } 

  public static void main(String[] args) {
      LinkedList l = new LinkedList();
      l.add(new Node('a',45));
      l.add(new Node('b',13));
      l.add(new Node('c',12));
      l.add(new Node('d',16));
      l.add(new Node('e',9));
      l.add(new Node('f',5));
      l.add(new Node('g',32));

      Huffman.makeTree(l);  
      printCodes(l);    
  }
}